<template>
  <div
    class="col col-grow bg-white flex column"
  >
    <div class="q-pa-md col-grow relative-position flex column">
      <div class="q-headline" v-if="!user">Doubleclick on any user from Compare table to see results here</div>
      <div class="q-mt-md flex column col-grow" v-else>
        <q-scroll-area class="col-grow">
          <div class="flex items-start no-wrap">
            <q-list class="segments__list-wrapper">
              <q-list-header>Segments</q-list-header>
              <q-item>
                <q-input
                  v-model="offset"
                  inverted-light
                  color="white"
                  stack-label="Offset"
                  dense
                  class="full-width"
                  type="number"
                  :min="0"
                  :step="0.01"
                />
              </q-item>
              <q-item
                v-for="({id, camera, start, end}, index) in segments"
                :key="id"
                class="cursor-pointer segments__list"
                @click.native="playSegment(index)"
                highlight
              >
                <q-item-main :label="`Camera ${camera}`">
                  <small v-html="`${formatTimeStamp(start)}<br/>${formatTimeStamp(end)}`"/>
                </q-item-main>
                <q-item-side v-if="playingIndex === index" right stamp="playing"/>
              </q-item>
            </q-list>
            <div class="q-pl-md col-grow">
              <div class="segments__player-wrapper">
                <video
                  class="segments__player"
                  controls
                  ref="video"
                />
              </div>
            </div>
          </div>
        </q-scroll-area>
      </div>
    </div>
  </div>
</template>

<script>
    import moment from 'moment';
    import apiMixin from '../../mixins/apiMixin';
    import endpointsMixin from '../../mixins/endpointsMixin';

    export default {
      name: 'runner-test',
      mixins: [apiMixin, endpointsMixin],
      props: {
        user: Object,
        attachedColumns: Object,
        columnCameras: Object,
        timeZone: String,
        date: String,
        isTimeZoneDetected: Boolean,
        timestampColumns: Object,
      },
      computed: {
        sortedSegments() {
          // eslint-disable-next-line no-nested-ternary
          return [...this.segments].sort(({ start: a }, { start: b }) => (a === b ? 0 : (a > b ? 1 : -1)));
        },
      },
      data() {
        return {
          computedTimings: [],

          segments: [],

          playingIndex: null,

          offset: 30,

          isComputing: false,
        };
      },
      watch: {
        user: {
          deep: true,
          handler() {
            this.playingIndex = null;
            this.$nextTick(() => {
              this.computeTimings();
            });
          },
        },
        offset() {
          this.$nextTick(() => {
            this.getSegments();
          });
        },
      },
      created() {
        this.computeTimings();
      },
      mounted() {
        if (this.$refs.video) {
          this.$refs.video.addEventListener('ended', () => {
            if ((this.playingIndex + 1) in this.segments) {
              this.playSegment(this.playingIndex + 1);
            } else {
              this.playSegment(null);
            }
          });
        }
      },
      methods: {
        playSegment(index) {
          this.playingIndex = index;
          this.$nextTick(() => {
            this.$refs.video.src = index === null ? null : this.segments[index].url;
            if (index !== null) {
              this.$refs.video.play();
            }
          });
        },
        formatTimeStamp(timestamp) {
          return moment.utc(timestamp).format('YYYY-MM-DD HH:mm:ss.SSS');
        },
        getSegments() {
          Promise.all(this.computedTimings.map(({ camera, timestamp }) => new Promise((resolve) => {
            this.fetchCameraSegments({
              locationId: this.$store.state.location.location.id,
              camId: camera,
              timestampStart: timestamp - this.offset * 1000,
              timestampEnd: timestamp + this.offset * 1000,
            })
              .then((results) => {
                results.forEach(({
                  id,
                  res_url: url,
                  segm_start: start,
                  segm_end: end,
                }) => {
                  this.segments.push({
                    id,
                    camera,
                    url,
                    start,
                    end,
                  });
                });

                resolve();
              });
          })));
        },
        computeTimings() {
          if (!this.user) {
            return;
          }
          this.isComputing = true;

          const timestampColumns = {};
          Object.entries(this.timestampColumns).forEach(([key, value]) => {
            timestampColumns[key] = [value[0], value[1]];
          });

          this.computeTimingsInTiming({
            users: [this.user],
            attachedColumns: this.attachedColumns,
            timestampColumns,
            columnCameras: this.columnCameras,
            timeZone: this.timeZone,
            date: this.date,
            isTimeZoneDetected: this.isTimeZoneDetected,
          })
            .then((res) => {
              this.computedTimings = res;
              this.isComputing = false;

              this.getSegments();
            });
        },
      },
    };
</script>

<style>
  .segments__list {
    max-height: 500px;
    overflow-y: auto;
  }

  .segments__list-wrapper {
    flex-shrink: 0;
    width: 300px;
  }

  .segments__player-wrapper {
    position: relative;
  }

  .segments__player-wrapper:before {
    content: '';
    padding-bottom: 56.25%;
    display: block;
  }

  .segments__player {
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
  }
</style>
